const DEFAULT_HASH ='0x175adf5fc058830a6319b8238ecc911db6e1b8dd40965629b5f0c5bee655598c'
let hash, seed = 0
const pal0 = ["#2b2d42", "#8d99ae", "#edf2f4", "#ef233c", "#d90429"]; 
const pal1 = ["#FFFFFF", "#000000", "#888888", "#444444", "#CCCCCC"]; 
const pal2 = ["#000814","#001d3d","#003566","#ffc300","#ffd60a"];
const pal3 = ["#fffcf2","#ccc5b9","#403d39","#252422","#eb5e28"]

 
let arrPals = [pal0,  pal1, pal2, pal3];
let lgt , f = 0, diag;
let cSize = Math.min(window.innerWidth, window.innerHeight);

function setup() {
    createCanvas(cSize, cSize);
    rectMode(CENTER)
    const params = getURLParams()
    hash = params.hash || DEFAULT_HASH
    seed = hashToSeed(hash);
    console.log('hash: ' + seed) 
    randomSeed(seed)
    noiseSeed(seed)
    console.log(hash, seed)
    pal = random(arrPals);
    lgt = pal.length;
    shuffle(pal, 1);
    A = random([4, 8, 12]);
    B = random([8, 16]);
    B1 = 1 + int(B - 1);
}

function draw() {
    f++;
    background(pal[0]);
    grid(A, 5e8, 0.3, 0.3, 1, 4);
    grid(B, 7e8, 0.09, 0.033, 0.4, B1);
    grid(78, 8e8, 0.25, 0.01, 0.4, int(f * 0.1) % 9);
    if(f==1) postMessageKoda();
}
grid = (nb, sd, nv1, nv2, prb, dv) => {
    let space = width / nb;
    noFill(), noStroke();
    let m = createVector(width / 2, height / 2)
    let cpt = -1;
    for (let i = -1; i < nb + 1; i++) {
        for (let j = -1; j < nb + 1; j++) {
            cpt++;
            let x = i * space, y = j * space;
            let n = noise(sd + i * nv2, j * nv2, +f * 0.01)
            if (n < prb) {
                ((cpt) % dv) ? fill(pal[int(noise(sd + i * nv1, j * nv1, f * 0.01) * lgt)]) : fill(0);
                rect(x + space / 2, y + space / 2, space * 2)
            } else if (n % 0.03 > 0.0125) {
                let nr = noise(7e9 + sd + i * nv1, j * nv1, f * 0.01)
                stroke(pal[int(nr * lgt)]);
                (nr > 0.5) ? line(x, y, x + space, y) : line(x + space, y + space, x + space, y)
            }
        }
    }
};

function windowResized() {
    canvasSize = min(windowWidth, windowHeight)
    resizeCanvas(canvasSize, canvasSize)
}

// KODA(HASH) UTILITY FUNCTIONS
// ----------------------------

// You can use your own function to convert the hash to a seed
function hashToSeed(hash) {
    let _seed = 0
    for (let hl = 0; hl < 60; hl = hl + 12) {
        _seed += parseInt(hash.substring(hl, hl + 12), 16)
    }
    return _seed
}

function postMessageKoda() {
    console.log('Talking')
    const canvas = document.querySelector('canvas')
    const message = {
        id: Date.now(),
        type: 'kodahash/render/completed',
        payload: {
            hash: hash,
            type: 'image/png',
            image: canvas ? canvas.toDataURL('image/png') : null,
            search: location.search,
            attributes: [],
        },
    }
    console.log('Sending', message)

    window.parent.postMessage(message, '*')
}
function keyPressed(){(isLooping())?noLoop():loop()}